## Search Agent Data

`AgentDataSearchPageResponse Beta.AgentData.Search(AgentDataSearchParamsparameters, CancellationTokencancellationToken = default)`

**post** `/api/v1/beta/agent-data/:search`

Search agent data with filtering, sorting, and pagination.

### Parameters

- `AgentDataSearchParams parameters`

  - `required string deploymentName`

    Body param: The agent deployment's name to search within

  - `string? organizationID`

    Query param

  - `string? projectID`

    Query param

  - `string collection`

    Body param: The logical agent data collection to search within

  - `IReadOnlyDictionary<string, FilterItem>? filter`

    Body param: A filter object or expression that filters resources listed in the response.

    - `Eq? Eq`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `IReadOnlyList<Exclude?> Excludes`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `Gt? Gt`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `Gte? Gte`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `IReadOnlyList<Include?> Includes`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `Lt? Lt`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `Lte? Lte`

      - `Double`

      - `string`

      - `DateTimeOffset`

    - `Ne? Ne`

      - `Double`

      - `string`

      - `DateTimeOffset`

  - `Boolean includeTotal`

    Body param: Whether to include the total number of items in the response

  - `Long? offset`

    Body param: The offset to start from. If not provided, the first page is returned

  - `string? orderBy`

    Body param: A comma-separated list of fields to order by, sorted in ascending order. Use 'field_name desc' to specify descending order.

  - `Long? pageSize`

    Body param: The maximum number of items to return. The service may return fewer than this value. If unspecified, a default page size will be used. The maximum value is typically 1000; values above this will be coerced to the maximum.

  - `string? pageToken`

    Body param: A page token, received from a previous list call. Provide this to retrieve the subsequent page.

### Returns

- `class AgentDataSearchPageResponse:`

  - `required IReadOnlyList<AgentData> Items`

    The list of items.

    - `required IReadOnlyDictionary<string, JsonElement> Data`

    - `required string DeploymentName`

    - `string? ID`

    - `string Collection`

    - `DateTimeOffset? CreatedAt`

    - `string? ProjectID`

    - `DateTimeOffset? UpdatedAt`

  - `string? NextPageToken`

    A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

  - `Long? TotalSize`

    The total number of items available. This is only populated when specifically requested. The value may be an estimate and can be used for display purposes only.

### Example

```csharp
AgentDataSearchParams parameters = new() { DeploymentName = "deployment_name" };

var page = await client.Beta.AgentData.Search(parameters);
await foreach (var item in page.Paginate())
{
    Console.WriteLine(item);
}
```

#### Response

```json
{
  "items": [
    {
      "data": {
        "foo": "bar"
      },
      "deployment_name": "deployment_name",
      "id": "id",
      "collection": "collection",
      "created_at": "2019-12-27T18:11:19.117Z",
      "project_id": "project_id",
      "updated_at": "2019-12-27T18:11:19.117Z"
    }
  ],
  "next_page_token": "next_page_token",
  "total_size": 0
}
```
